version: '3'
services:

  ###> OPENAPI ###
  swagger-editor:
    image: swaggerapi/swagger-editor
    ports:
      - "19000:8080"
    networks:
      - book-frontend
  swagger-ui:
    image: swaggerapi/swagger-ui
    volumes:
      - ./public/v1:/swagger
    environment:
      SWAGGER_JSON: /swagger/openapi.json
    ports:
      - "19010:8080"
    networks:
      - book-frontend
  ###< OPENAPI  ###

  ###> REDIS ###
  redis:
    image: redis:6-alpine
    ports:
      - "6379:6379"
    networks:
      - book-frontend
  ###< REDIS  ###

  ###> EX-BOOK-LIST-API ###
  book-list:
    image: "registry.gitlab.com/mobica-workshops/examples/python/flask/book-list-mockup:latest"
    ports:
      - "8882:8080"
    networks:
      - book-frontend
  ###< EX-BOOK-LIST-API ###

  ###> EX-BOOK-ADMIN-API ###
  book-admin:
    image: "registry.gitlab.com/mobica-workshops/examples/python/flask/book-admin-mockup:latest"
    ports:
      - "8883:8080"
    networks:
      - book-frontend
  ###< EX-BOOK-ADMIN-API ###

  ###> EX-BOOK-API-GATEWAY ###
  book-bff:
    image: "registry.gitlab.com/mobica-workshops/examples/go/gorilla/book-bff:latest"
    command: ["serve", "--config", "/secrets/local.env.yaml", "-b", "0.0.0.0", "-p", "8080", "-c"]  # cors
    ports:
      - "8881:8080"
    volumes:
      - ./secrets/book-bff/docker.env.yaml:/secrets/local.env.yaml
    networks:
      - book-frontend
  ###< EX-BOOK-API-GATEWAY ###

networks:
  book-frontend:
    driver: bridge

volumes:
  data-volume:
  book-list-db-data:
    driver: local
  book-admin-db-data:
    driver: local
